<template>
  <b-container fluid="lg">
    <b-form v-loading="listLoading" inline @submit="onSubmit" @reset="onReset">
      <b-row class="w-100 mb-2">
        <b-col sm="12" lg="3">
          <b-row class="w-100">
            <b-col class="text-right" sm="12" md="12" lg="3">
              {{ $t('form.province') }}
            </b-col>
            <b-col sm="12" md="12" lg="9">
              <b-form-input
                v-model="address.province"
                class="ml-2 mr-2"
                :placeholder="$t('form.province')"
              >&nbsp;</b-form-input>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="12" lg="4">
          <b-row class="w-100">
            <b-col class="text-right" sm="12" md="12" lg="4">
              {{ $t('form.city') }}
            </b-col>
            <b-col sm="12" md="12" lg="8">
              <b-form-input
                v-model="address.city"
                class="ml-2 mr-2"
                :placeholder="$t('form.city')"
              >&nbsp;</b-form-input>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="12" lg="4">
          <b-row class="w-100">
            <b-col class="text-right" sm="12" md="12" lg="3">
              {{ $t('form.region') }}
            </b-col>
            <b-col sm="12" md="12" lg="9">
              <b-form-input
                v-model="address.region"
                class="ml-2 mr-2"
                :placeholder="$t('form.region')"
              >&nbsp;</b-form-input>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="1">&nbsp;</b-col>
      </b-row>
      <b-row class="w-100 mb-2">
        <b-col sm="12" lg="3">
          <b-row class="w-100">
            <b-col class="text-right" sm="12" md="12" lg="3">
              {{ $t('form.address') }}
            </b-col>
            <b-col sm="12" md="12" lg="9">
              <b-form-input
                v-model="address.address"
                class="ml-2 mr-2"
                :placeholder="$t('form.address')"
              >&nbsp;</b-form-input>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="12" lg="4">
          <b-row class="w-100">
            <b-col class="text-right text-bold-700" sm="12" md="12" lg="4">
              {{ $t('form.geoPlace') }}
            </b-col>
            <b-col sm="12" md="12" lg="8">
              <b-form-input
                v-model="address.geo_place"
                class="ml-2 mr-2"
                :placeholder="$t('form.geoPlace')"
              >&nbsp;</b-form-input>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="12" lg="4">
          <b-row class="w-100">
            <b-col sm="12" md="12" lg="3">
              {{ $t('form.rowColumn') }}
            </b-col>
            <b-col sm="12" md="12" lg="9">
              <b-form-select
                v-model="address.row"
                :options="optionsRowColumn"
                sm="12"
                md="12"
                lg="8"
                :placeholder="$t('form.row')"
              >&nbsp;</b-form-select>
              <b-form-select
                v-model="address.column"
                :options="optionsRowColumn"
                sm="12"
                md="12"
                lg="8"
                :placeholder="$t('form.column')"
                type="number"
                @keyup="toIntColumn"
              >&nbsp;</b-form-select>
            </b-col>
          </b-row>
        </b-col>
        <b-col sm="1">
          <b-button type="submit" variant="primary" class="pointer" @click="setAttributeAddress">{{ $t('form.submit') }}</b-button>
        </b-col>
      </b-row>
      <div class="w-100 p-3">
        <b-card no-body>
          <b-tabs card>
            <b-tab :title="$t('route.counters')" active>
              <b-row v-for="n in row" :key="n" class="mr-5 mt-5">
                <b-row class="w-100 mb-2 ltr">
                  <b-col v-for="x in column" :key="x" class="text-center">
                    <span class="pointer" @click="setCounterAttribute(n, x)">
                      <i class="fa fa-angle-up text-white-50 bg-dark counters">&nbsp;</i>
                      <br>
                      {{ n }}, {{ x }}
                      <br>
                      {{ counters[n][x] }}
                    </span>
                  </b-col>
                </b-row>
              </b-row>
            </b-tab>
            <b-tab :title="$t('form.bani')">
              <b-card-text>
                <b-row class="w-100 mt-5 mb-5">
                  <b-col class="text-right" sm="2">
                    <label>
                      {{ $t('form.bani') }}
                    </label>
                  </b-col>
                  <b-col>
                    <v-select v-model="bani.bani" :filterable="false" :options="banis" @search="onSearchBanis">
                      <template slot="no-bains">
                        {{ $t('form.typeToSearch') }}
                      </template>
                      <template slot="option" slot-scope="option">
                        <div class="d-center">
                          {{ option.full_name }}
                        </div>
                      </template>
                      <template slot="selected-option" slot-scope="option">
                        <div class="selected d-center">
                          {{ option.full_name }}
                        </div>
                      </template>
                    </v-select>
                  </b-col>
                  <b-col>
                    <b-form-select v-model="bani.counterType" :options="options">&nbsp;</b-form-select>
                  </b-col>
                  <b-col>
                    <b-button type="submit" variant="primary" class="pointer" @click="sendBani">{{ $t('form.submit') }}</b-button>
                  </b-col>
                  <b-col>&nbsp;</b-col>
                </b-row>
              </b-card-text>

              <!--<el-table v-loading="listLoading" :data="getListBani" border fit highlight-current-row style="width: 100%">-->
              <!--<el-table-column align="center" :label="$t('form.province')">-->
              <!--<template slot-scope="scope">-->
              <!--<span>{{ scope.row.bani }}</span>-->
              <!--</template>-->
              <!--</el-table-column>-->
              <!--<el-table-column align="center" :label="$t('row.operation')">-->
              <!--<template slot-scope="scope">-->
              <!--<span class="pointer fa fa-check mr-1 ml-1" @click="acceptAddress(scope.row.id)">&nbsp;</span>-->
              <!--<span class="pointer fa fa-remove mr-1 ml-1" @click="rejectAddress(scope.row.id)">&nbsp;</span>-->
              <!--</template>-->
              <!--</el-table-column>-->

              <!--</el-table>-->

            </b-tab>
          </b-tabs>
        </b-card>
      </div>
    </b-form>
    <el-dialog :title="$t('dialog.counterAttribute') + modalHeader" :visible.sync="setCounterAttributeModal">
      <div class="form-container">
        <el-form ref="verificationForm" :model="counterAttribute" label-position="left" class="register-form" style="max-width: 500px;">
          <b-form-input
            v-model="counterAttribute.subscribtion_code"
            class="ml-2 mr-2"
            autocomplete="off"
            :placeholder="$t('form.subscriptionNumber')"
            @keydown="qrcodeSubscribtionCode()"
          >&nbsp;</b-form-input>
          <b-form-input
            v-model="counterAttribute.qr_code"
            class="ml-2 mr-2"
            :placeholder="$t('route.qrcodes')"
          >&nbsp;</b-form-input>
          <el-form-item prop="name">
            <p class="decode-result">Last result: <b>{{ result }}</b></p>
            <qrcode-stream @decode="onDecode" @init="onInit" />
          </el-form-item>
          <el-form-item :label="$t('form.counterType')" prop="name">
            <b-form-select v-model="counterAttribute.counter_type" :options="optionCounterType" @change="selectCounterType()">&nbsp;</b-form-select>
          </el-form-item>
          <b-form-input
            v-if="counter_type == 1"
            v-model="counterAttribute.counter_first_number"
            class="ml-2 mr-2"
            :placeholder="$t('form.counter_first_number')"
          >&nbsp;</b-form-input>
          <b-form-input
            v-if="counter_type == 1"
            v-model="counterAttribute.counter_second_number"
            class="ml-2 mr-2"
            :placeholder="$t('form.counter_second_number')"
          >&nbsp;</b-form-input>
          <b-form-input
            v-if="counter_type == 1"
            v-model="counterAttribute.counter_third_number"
            class="ml-2 mr-2"
            :placeholder="$t('form.counter_third_number')"
          >&nbsp;</b-form-input>
        </el-form>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="setCounterAttributeModal = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="setAttributeCounter()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
  </b-container>
</template>

<script>
import Address from '@/api/address';
const addresResource = new Address('address');
import { QrcodeStream } from 'vue-qrcode-reader';

import 'vue-select/src/scss/vue-select.scss';
import i18n from '@/lang';

export default {
  name: 'AddressList',
  components: { QrcodeStream },
  data() {
    return {
      list: null,
      address_id: null,
      modalHeader: '',
      listLoading: false,
      setCounterAttributeModal: false,
      counterAttribute: {},
      counter_type: 0,
      row: 0,
      column: 0,
      address: {},
      bani: {},
      banis: [],
      options: [
        { value: 'Owner', text: this.$i18n.t(`row.owner`) },
        { value: 'Renter', text: this.$i18n.t(`row.renter`) },
        { value: 'ColleagueManager', text: this.$i18n.t(`row.colleagueManager`) },
      ],
      optionsRowColumn: [
        { value: 1, text: 1 }, { value: 2, text: 2 }, { value: 3, text: 3 }, { value: 4, text: 4 },
        { value: 5, text: 5 }, { value: 6, text: 6 }, { value: 7, text: 7 }, { value: 8, text: 8 },
      ],
      optionCounterType: [
        { value: 'counter_new', text: this.$i18n.t(`form.newCounter`) },
        { value: 'counter_old', text: this.$i18n.t(`form.oldCounter`) },
      ],
      query: {
        id: '',
      },
      result: '',
      error: '',
    };
  },
  created() {
    const id = this.$route.params && this.$route.params.id;
    this.query.id = id;
    this.getAddressCounter(id);
    this.getListBani(id);
  },
  methods: {
    onDecode(result) {
      result = result.replace('https://energynote.ir/b/', '');
      this.result = result;
      this.counterAttribute.qr_code = result;
    },

    async onInit(promise) {
      try {
        await promise;
      } catch (error) {
        if (error.name === 'NotAllowedError') {
          this.error = 'ERROR: you need to grant camera access permisson';
        } else if (error.name === 'NotFoundError') {
          this.error = 'ERROR: no camera on this device';
        } else if (error.name === 'NotSupportedError') {
          this.error = 'ERROR: secure context required (HTTPS, localhost)';
        } else if (error.name === 'NotReadableError') {
          this.error = 'ERROR: is the camera already in use?';
        } else if (error.name === 'OverconstrainedError') {
          this.error = 'ERROR: installed cameras are not suitable';
        } else if (error.name === 'StreamApiNotSupportedError') {
          this.error = 'ERROR: Stream API is not supported in this browser';
        }
      }
    },
    onSearchBanis(search, loading) {
      fetch(
        '/api/searchBanis?q=' + search
      ).then(res => {
        res.json().then(json => (this.banis = json.items));
        console.log(this.banis);
        loading(false);
      });
    },
    async getAddressCounter() {
      this.listLoading = true;
      const { counters } = await addresResource.getAddressCounter(this.query);
      const { address } = await addresResource.getAddress(this.query);
      this.counters = counters;
      this.address = address;
      this.row = address.row;
      this.column = address.column;
      this.address_id = address.id;
      this.listLoading = false;
    },
    async getListBani(id) {
      this.listLoading = true;
      this.query.id = id;
      const { result } = await addresResource.getListBani(this.query);
      this.listBani = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    selectCounterType(){
      if (this.counterAttribute.counter_type === 'counter_new'){
        this.counter_type = 1;
      } else {
        this.counter_type = 0;
      }
    },
    async qrcodeSubscribtionCode(){
      if (this.counterAttribute.subscribtion_code > 100){
        const response = await addresResource.qrcodeSubscribtionCode(this.counterAttribute);
        this.counterAttribute.qr_code = response.qrcode;
      }
    },
    setAttributeCounter() {
      this.counterAttribute.metadata = this.modalHeader;
      this.counterAttribute.address_id = this.address_id;
      addresResource.setAttributeCounter(this.counterAttribute)
        .then(response => {
          if (response.success){
            this.setCounterAttributeModal = false;
            this.$message({
              message: i18n.t(`field.created`),
              type: 'success',
              duration: 5 * 1000,
            });
            this.getAddressCounter();
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          // this.setCounterAttributeModal = false;
        });
    },
    setAttributeAddress() {
      this.listLoading = true;
      const { result } = addresResource.setAttributeAddress(this.address);
      console.log(result);
      this.row = parseInt(this.address.row);
      this.column = parseInt(this.address.column);
      this.listLoading = false;
    },
    sendBani() {
      this.bani.address_id = this.query.id;
      addresResource.sendBani(this.bani)
        .then(response => {
          this.$message({
            message: i18n.t(`field.created`),
            type: 'success',
            duration: 5 * 1000,
          });
        })
        .catch(error => {
          console.log(error);
        })
        .finally(() => {
          this.setCounterAttributeModal = false;
        });
    },
    sendVerification() {
      this.setCounterAttributeModal = true;
    },
    setCounterAttribute(n, x) {
      this.modalHeader = n + ',' + x;
      this.counterAttribute = {};
      this.result = '';
      this.setCounterAttributeModal = true;
    },
    toIntRow() {
      // this.address.row = parseInt(this.address.row);
      // console.log(this.address.row);
    },
    toIntColumn() {
      // this.address.column = parseInt(this.address.column);
      // console.log(this.address.column);
    },
    onSubmit(evt) {
      evt.preventDefault();
    },
    onReset(evt) {
      evt.preventDefault();
      // Reset our form values
      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },
  },
};
</script>
